/*
	file name : oddMagic.c
	Description : ODD Magic Matrix Implementation
	_]N}@
*/

#include <stdio.h>
#include <stdlib.h>
#define MAX	15  /*x}̤j15 x 15 */

int Square[MAX][MAX];  /*wqƯx}*/ 
int N;  /*x}Cjpܼ*/	

void Magic();

int main()
{
	int i,j;

	do {  /*Ū]Nx}jpN,N _ƥB0 <= N <= 15 */
		printf("\nEnter odd matrix size : ");
		scanf("%d",&N);
		if (N % 2 == 0 || N <= 0 || N > 15)
			printf("Should be > 0 and < 15 odd number");
		else
			break;
	} while (1);

	Magic();  /*Nsquare ܬN x N ]Nx}*/

	/*]Nx}G*/
	printf("\nThe %d*%d Magic Matrix\n",N,N);
	for (i = 1; i <= 5*N; i++)
        printf("-");
    printf("\n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
			printf("%5d",Square[i][j]);
		printf("\n");
	}
	system("PAUSE");
	return 0;
}

void Magic()
{
	int i,j,p,q,key;

	/*lƯx}e,x}M0 */
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			Square[i][j] = 0;

	Square[0][(N-1)/2] = 1; /*N1̤ܳWCm*/
	key = 2;
	i = 0;
	j = (N-1)/2;    /* i,jOثeҦbm*/

	while (key <= N*N)
	{
		p = (i-1) % N;  /* p,qU@Bm,i,jU1_*/
		q = (j-1) % N;
		/* p < 0 (WX}W)*/
		if (p < 0)  p = N - 1; /* hNp N -1(̤UC) */
		if (q < 0)  q = N - 1; /* q < 0 (WX}) */
		/* hNq N -1(̥k) */
		if (Square[p][q] != 0)  /*P_U@BO_wƦr*/
			i = (i+1) % N;  /*wh i U ( bȤU*/
		else {
			i = p;  /*NU@Bmassingثem */
			j = q;
		}
		Square[i][j] = key;
		key++;
	}
}
